/*
 *  Scope
 */
'use strict';

// Global scope -----------------
// Global scope consists of the properties of the global object
var a = 5;

function doIt(a) {
    console.log(a);
}

// All top level declarations ends up in
// global scope Global scope is
// accessible as an object, i.e. window!
window.doIt(window.a);

// No block scope!!! --------------------------------------
var x = 10;
if (true) {
    var x = 20;
    console.log(x); // 20
}
console.log(x); // 20

// Variable declarations must use var ---------------
function hmm() {
    // x = 6;  // Not a variable. Will. Should be var x = 6
    // end up as property of global object!
} // Strict mode will generete error for this
hmm();
// console.log(noVar);  // m global!!!

// Function scope 1 --------------------------------------
var x = 10;
if (true) {
    (function(x) { // Function scoped x (using IIFE to create scope)
        console.log(x); // 20
    })(20);
}
console.log(x); // 10

// Function scope 2 -----------------------

var x = 10; // Global scope
function foo() { // Global
    var y = 20; // Local  ( Total: Local + Global)
    bar(); // Ok, declaration hoisted
    function bar() {
        var z = 30; // Local scope (Total: Local + Closure (outer function) + Global)
        console.log(x + y + z);
    }
}
foo1();

// Lexically scooped 1  -----------------------
// The static structure of a program determines the scope of a variable

function foo1() {
    var x = 10;
    var y = 20;
    return function() {
        console.log([x, y]);
    };
}
var x = 30;
var bar1 = foo1(); // anonymous function is returned
bar1(); // [10, 20] Nearest lexical scoope from  declaration

// Lexically scooped 2 ---------------------------------------
var x = 10;
var y = 20;

function foo2() { // Nearest lexical scope is global
    console.log(x, y);
}
foo2(); // 10, 20

function bar2() {
    var y = 30;
    console.log(x, y); // 10, 30
    foo2(); // 10, 20  Nearest lexical scoope from  declaration
}
bar2();

// Lexical scooped 3 ------------------------------------
var myAlerts = [];
for (var i = 0; i < 5; i++) {
    myAlerts.push( // Store functions in array
            function inner() {
        console.log(i);
    });
}

myAlerts[0](); // 5
myAlerts[1](); // 5
myAlerts[2](); // 5
myAlerts[3](); // 5
myAlerts[4](); // 5
