/* 
 *  Closures 
 */
'use strict';

// Closure 1 -------------------------------------
var add = (function () {
    var counter = 0;
    return function () {
        console.log(counter);
        return counter += 1;
    };
})();

add();
add();
add();

// Closure 2 -------------------------------------

function curry(a) {
    return function (b) {
        return a * b;  // Will remember 'a' after outer function finished.
    };
}
var f = curry(5);
console.log(f(3));

// Closeure 3 ----------------------------------------------

// Nice view of closures and
// scope chain (if debug in Chrome Devtools)

// var gl = 7;   Global also accessible following scope chain
function one() {
    var a = 1;
    two();

    function two() {
        var b = 2;
        three();

        function three() {
            var c = 3;
            console.log(a + b + c);

        }
    }
    return two;
}

var t = one();  // 6
t();            // 6

