/*
 * Checking event capturing bubbling
 */

// Only bubble (only one handler)
/*window.onload = function() {
    document.getElementById("A").onclick = traceEvent;
    document.getElementById("B").onclick = traceEvent;
    document.getElementById("C").onclick = traceEvent;
    document.getElementById("D").onclick = traceEvent;
    document.getElementById("btnClear").addEventListener("click", clear, false);
};
*/
// Capture and Bubble (more handlers)
window.onload = function() {
    document.getElementById("A").addEventListener("click", traceEvent, false);
    document.getElementById("A").addEventListener("click", traceEvent, true);
    document.getElementById("B").addEventListener("click", traceEvent, false);
    document.getElementById("B").addEventListener("click", traceEvent, true);
    document.getElementById("C").addEventListener("click", traceEvent, false);
    document.getElementById("C").addEventListener("click", traceEvent, true);
    document.getElementById("D").addEventListener("click", traceEvent, false);
    document.getElementById("D").addEventListener("click", traceEvent, true);
    document.getElementById("btnClear").addEventListener("click", clear, false);
};

// JQuery style. Only bubble (one handler?)
/*$(function() {
    $("#A").on("click", traceEvent);
    $("#B").on("click", traceEvent);
    $("#C").on("click", traceEvent);
    $("#D").on("click", traceEvent);
    $("#btnClear").on("click", clear);
})*/

function traceEvent(e) {

    var target = e.target;
    var current = e.currentTarget;
    var phase = e.eventPhase;

    if (e.eventPhase === Event.CAPTURING_PHASE) { // 1
        console.log("Capuring " + current.id);
    } else if (e.eventPhase === Event.AT_TARGET) { // 2
        console.log("At target " + target.id);
        //console.log("Stop bubbling");      // Uncomment to see
        //e.stopPropagation();
    } else if (e.eventPhase === Event.BUBBLING_PHASE) { // 3
        console.log("Bubbling " + current.id);
    } else {}

    document.getElementById("traceOut").value += "Target = " + target.id + "; Phase = " + phase + "; Current = " + current.id + ";\n";
}

function clear() {
    document.getElementById("traceOut").value = "";
}
