/*

    The router for all /list/* pathes

    Control part

    NOTE:  Order of pathes IMPORTANT
    Express will try to match top down
    If something before matches, .... then what should match NOT executed.
*/

var express = require('express');
var Person = require('../models/person.js');
var personList = require('../models/personList.js');

// Access the model objects!
//var personList = new PersonList();

// Create the router
var router = express.Router();

// List notes for current user
// next() without parameter invokes the next route handler in framework(?!)
router.get('/', function(req, res, next) {
    // Invoke Mustache, send viewmodel
    res.render('list', {
        title: 'List',
        personList: personList.getPersons()
    });
});

router.get('/add', function(req, res, next) {
    console.log("Get add");
    res.render('add');
});

// Ok, works here
router.post('/add', function(req, res, next) {
    console.log("Post add " + req.body.id + " " + req.body.name);
    // Very nice to forget parseInt here!
    var p = new Person(parseInt(req.body.id), req.body.name);
    personList.add(p);
    res.redirect("/list");
});

router.get('/delete', function(req, res, next) {
    //console.log("Get delete " + req.params.id);
    console.log("Get delete " + req.query.id);
    var person = personList.getById(parseInt(req.query.id));
    console.log("Found " + person);
    res.render('delete', {
        title: 'Delete Note',
        person: person
    });
});

router.post('/delete', function(req, res, next) {
    console.log("Post delete " + req.body.id);
    personList.delete(parseInt(req.body.id));
    res.redirect("/list");
});

module.exports = router;
