/*
    Uses mocha and chai

	npm install -g mocha
	npm install chai

	Must have dir /test for tests

	To run
	$ mocha

	Sadly it seems complicated to debug the tests.

*/
var assert = require('assert');
var Person = require('../models/person.js');
var PersonList = require('../models/personlist.js');

describe('Person', function() {
    describe('# Constructor func', function() {
        it('Set default data', function() {
            var n = new Person(55, "otto");
            assert.equal(n.id, 55);
            //console.log(n);
        });
    });

});

describe('PersonList', function() {
    describe('#getById', function() {
        it('should find dummy data', function() {
            var l = new PersonList();
            // Default dummy data
            var note = l.getById(1);
            assert.equal(note.id, 1);
        });
    });
    describe('#create', function() {
        it('add a person', function() {
            var l = new PersonList();
            //console.log(todolist.getNotes());
            var person = new Person(23, "otto");
            l.create(person);
            assert.equal(l.getById(23).name, "otto");
        });
    });

    describe('#delete', function() {
        it('remove person', function() {
            var l = new PersonList();
            var id = l.getPersons()[0].id;
            l.delete(id);
            assert.equal(l.getById(id), null);

            var person = new Person(23, "otto");
            l.create(person);
            l.delete(person.id);
            assert.equal(l.getById(23), null);
        });
    });
});
