package jsp.view;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Data for JSP pages (an instance of this class i used in the JSP page)
 *
 * @author hajo
 */
public class ViewModel {

    private static final Logger LOG = Logger.getAnonymousLogger();
    // Emulate OO model
    private final Person[] persons = {
        new Person(1, "olle"),
        new Person(2, "pelle"),
        new Person(3, "fia")}; 

    public ViewModel() {
        LOG.log(Level.INFO, "View model alive {0}", this);
    }

    public Person[] getPersons() {
        return persons;
    }

    public Person getPerson(int i) {
        for( Person p : persons){
            if( p.getId() == i){
                LOG.log(Level.INFO, "Found " + p);
                return persons[i-1];
            }
        }
        return null;
    }

}
