package query.dao;

import com.querydsl.jpa.impl.JPAQueryFactory;
import java.math.BigDecimal;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import query.model.Product;
import query.model.QProduct;

/**
 * NOTE: Many named queries for single attribute selection, see Manufacturer
 * class
 *
 * @author hajo
 */
@Stateless
public class ProductDAO extends AbstractDAO<Product, Integer> {

    @PersistenceContext
    private EntityManager em;

    public ProductDAO() {
        super(Product.class);
    }

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

     // Silly query, just a demo
    public double totalCostForAll() {
        QProduct p = QProduct.product;
        JPAQueryFactory cf = new JPAQueryFactory(em);
        BigDecimal r =  cf.from(p).select(p.purchaseCost.sum()).fetchOne();
        return (r != null) ? r.doubleValue(): 0;
    }
    

}
