
package query.test;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.inject.Inject;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import query.dao.CustomerDAO;
import query.dao.ManufacturerDAO;
import query.dao.ProductDAO;
import query.model.Customer;
import query.model.Manufacturer;

/**
 *
 * @author hajo
 */
@WebServlet(name = "QueryServlet", urlPatterns = {"/qs"})
public class QueryServlet extends HttpServlet {

  
    @Inject
    ManufacturerDAO mdao;
    
    @Inject
    ProductDAO pdao;
    
    @Inject
    CustomerDAO cdao;
    
    private static final Logger LOG = Logger.getLogger(QueryServlet.class.getName());
    private static final Level I = Level.INFO; 
    
    
    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
      
        // Uncomment and test
        //testGetByStates();
        //testGetByStatesSQL();
        //testGetCostForAll();
        testGetVIPCustomersSQL();
        //testGetVIPCustomers();
        
        
        response.setContentType("text/html;charset=UTF-8");
        try (PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet QueryServlet</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>See output in GlassFish Server output (NetBeans)</h1>");
            out.println("</body>");
            out.println("</html>");
        }
    }
     
    private void testGetByStates(){
        String[] states = { "CA", "OH" };
        List<Manufacturer> ms = mdao.getByStates(states);
        for( Manufacturer m : ms){
            LOG.log(I, m.getName() + " " + m.getState());
        }  
    }
    
    private void testGetByStatesSQL(){
        String[] states = { "CA", "OH" };
        List<Manufacturer> ms = mdao.getByStatesSQL(states);
        for( Manufacturer m : ms){
            LOG.log(I, m.getName() + " " + m.getState());
        }  
    }
    
    private  void testGetCostForAll(){
        double d = pdao.totalCostForAll();
        LOG.log(I, "Value " + d);
    }
    
     private  void testGetVIPCustomersSQL(){
        List<Customer> cs = cdao.VIPCustomersSQL();
        for( Customer c : cs){
            LOG.log(I, c.getName());
        }  
    }
    
    private  void testGetVIPCustomers(){
        List<Customer> cs = cdao.VIPCustomers();
        for( Customer c : cs){
            LOG.log(I, c.getName());
        }  
    }

}
