/*
    Person is a model i.e. representing a table
    Models are promise based
*/

var Sequelize = require('sequelize');
var sequelize = require('../db/personsorm.js');

// Create mapping between model and table
var Person = sequelize.define('Persons', {
    id: {
        type: Sequelize.BIGINT,
        autoIncrement: true,
        primaryKey: true
    },
    name: {
        type: Sequelize.STRING
    }
}, {
    //freezeTableName: true // Model tableName will be the same as the model name
    timestamps: false
});

/*
  Many "invisible" methods for models
  build,
  save,
  findAll,
  findById,
  findOne,
  update,
  delete

  See http://docs.sequelizejs.com/en/latest/docs/models-usage
      http://docs.sequelizejs.com/en/latest/docs/instances
*/

module.exports = Person;
