
$(function() {
    $("#getPersons").on("click", rest.getPersons);
    $("#getById").on("click", rest.getById);
    $("#add").on("click", rest.add);
    $("#delete").on("click", rest.delete);
    $("#clear").on("click", rest.clear);

});

// Singleton object
var rest = (function() {
    // Node backend
    var baseURL = 'http://localhost:3000/list/';
    // JEE Backend
    //var baseURL = 'http://localhost:8080/persons/rest/list/';

    return {
        getPersons: function() {
            console.log("Before ajax get call");
            $.get(baseURL).then(function(json) {
                console.log(json);
                $("#personsResult").html(JSON.stringify(json));
            }).fail( // This is jQuery, standard Promise is catch()
                    function(error) { // Error
                $("#error").html(JSON.stringify(error));
            });
            console.log("After ajax get call");
        },
        getById: function() {
            var id = $("#id").val();
            $.get(baseURL + id).then(function(json) {
                console.log(json);
                $("#idResult").html(JSON.stringify(json));
            }).fail(function(error) { // Error
                $("#error").html(JSON.stringify(error));
            });
            console.log("After ajax get call");
        },
        delete: function() {
            var id = $("#id").val();
            $.ajax({
                url: baseURL + id,
                type: 'DELETE',
                success: function() {
                    console.log("Delete " + id);
                }
            });
        },
        add: function() {
            var name = $("#name").val();
            console.log(name);
            $.post(baseURL, {name: name}).fail(function(error) {
                $("#error").html(JSON.stringify(error));
            });
        },
        clear: function() {
            $(".result").empty();
        }
    }
})();
