/*

	Application entry (= main)
*/
var express = require('express');
var path = require('path');

var bodyParser = require('body-parser');
var service = require('./routes/service');

var app = express();

app.get('/', function(req, res) {
    res.sendFile(path.join(__dirname + '/index.html'));
});
// Used for static resources (must have first arg, to make path absolute)
app.use('/public', express.static(path.join(__dirname, '/public')));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({extended: false}));

// The routes and routers
app.use('/service', service);

app.use(function(err, req, res, next) {
    err.status = 404;
    next(err);
});

// Development error handler
// will print stacktrace
if (app.get('env') === 'development') {
    app.use(function(err, req, res, next) {
        res.status(err.status || 500);
    });
}
// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
    res.status(err.status || 500);
});
app.listen(3000);
console.log("Listening to localhost:3000");

module.exports = app;
