package cache.core;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

/**
 A basic OO model object

 @author hajo
 */
/*

 NOTE: If serving XML we must have annotation (JAXB mapping) 
 like below (if JSON we don't need)
 */
//@XmlRootElement
/*@XmlAccessorType(XmlAccessType.PROPERTY)
 @XmlType(name = "PersonType", propOrder = {
 //"pnumb",
 "fname",
 "age"
 })*/
@EqualsAndHashCode(of = "id")
public class Person {

    @Getter
    @Setter
    private Long id;
    @Getter
    @Setter
    private String fname;
    @Getter
    @Setter
    private int age;

    // Must have for JAXB
    protected Person() {
    }

    public Person(Long id, String fname, int age) {
        this.id = id;
        this.fname = fname;
        this.age = age;
    }

    //@XmlElement(required = true)
    /*public String getFname() {
     return fname;
     }*/
    //@XmlAttribute(required = true)
    /*public Long getId() {
     return id;
     }*/
    //@XmlElement(required = true)
    /*public int getAge() {
     return age;
     }*/
    @Override
    public String toString() {
        return "Person{" + "id=" + id + ", fname=" + fname + ", age=" + age + '}';
    }

}
