package edu.chl.hajo.stateful;

import edu.chl.hajo.cycle.*;
import java.io.Serializable;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.html.HtmlInputText;
import javax.inject.Named;
import static edu.chl.hajo.cycle.LogUtil.*;
import javax.faces.context.FacesContext;
/**
 To hold data (BUT there's also a state)

 @author hajo
 */
@Named("stateful")
@SessionScoped
public class StatefulBean implements Serializable {

    private String data = "default value";
    private HtmlInputText intext;
    private String content;

    public String getData() {
        // Can't call intext.getValue(), OutOfMemoryException
        info("*** getData: HTMLInputtext content " + content, RED);
        info("*** getData: Bean data is " + data, RED);
        String state = FacesContext.getCurrentInstance().getApplication().
                getStateManager().getViewState(FacesContext.getCurrentInstance());
        info("*** ViewState is " + state);
        return data;
    }

    public void setData(String data) {
        if (intext != null) {
            content = (String) intext.getValue();
            info("*** setData: HTMLInputtext content " + content, RED);
        } else {
            info("*** setData: HTMLInputtext is null", RED);
        }
        this.data = data;

    }

    public HtmlInputText getIntext() {
        return intext;
    }

    public void setIntext(HtmlInputText intext) {
        this.intext = intext;
    }

}
