/*
  Using Web components templates
*/

// This is ES6, a class (just syntactic sugar)
class LoginElement extends HTMLElement {

    // An instance of the element is created or upgraded
    constructor() {
        super(); // Always first, establish prototype chain
    }

    // Called every time the element is inserted into the DOM.

    connectedCallback() {
        let t = document.querySelector('#login-template');
        const clone = document.importNode(t.content, true);
        this.attachShadow({mode: 'open'}).appendChild(clone);
        // Store part of component for later use
        this.email = this.shadowRoot.querySelector('#email');
        this.passwd = this.shadowRoot.querySelector('#passwd');
        //this.btnLogin = this.shadowRoot.querySelector('#btnLogin');

        this.shadowRoot.querySelector('#btnLogin').addEventListener("click", function() {
            console.log("Clicked" + this.email.value + " " + this.passwd.value);
        }.bind(this));
    }

    // Called every time the element is removed from the DOM
    disconnectedCallback() {
        this.shadowRoot.innerHTML = '';
    }

    // Pre: listener must be able to handle email passwd args
    addEventListener(event, listener) {
        //let self = this;
        /*this.btnLogin.addEventListener('click', function(e) {
            console.log("Clicked");
        });*/
        //this.btnLogin.addEventListener(event, listener);
    }
}

/*
  The name of a custom element must contain a dash (-)
  You can't register the same tag more than once
  Custom elements cannot be self-closing
*/
customElements.define('log-in', LoginElement);
